Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSTable

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSActionObject
              com.flagstone.transform.FSTable

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSTable

extends FSActionObject

FSTable is used to create a table of string literals that can be referenced by an index rather than using the literal value when executing a sequence of actions.

Variables and built-in functions are specified by their name and the FSTable class contains a table of the respective strings. References to a variable or function can then use its index in the table rather than the name resulting in a more compact representation when the actions are encoded into binary form.

Attributes
type | Identifies the action when it is encoded. Read-only.
values | An array of up to 65536 strings.

The use of the FSTable class is illustrated in the following simple expression:

     var1 = (var1 + var2) / (var1 - var3);

This can be translated into the following sequence of actions:

     FSTable values = new FSTable();

     values.add("var1");
     values.add("var2");
     values.add("var3");

     actions.add(values);

     actions.add(new FSPush(FSTableIndex(0))); // var1
     actions.add(FSAction.GetVariable());
     actions.add(new FSPush(FSTableIndex(0))); // var1
     actions.add(FSAction.GetVariable());
     actions.add(new FSPush(FSTableIndex(1))); // var2
     actions.add(FSAction.GetVariable());
     actions.add(new FSAction(FSAction.Add));
     actions.add(new FSPush(FSTableIndex(0))); // var1
     actions.add(FSAction.GetVariable());
     actions.add(new FSPush(FSTableIndex(2))); // var3
     actions.add(FSAction.Subtract());
     actions.add(FSAction.Divide());
     actions.add(FSAction.SetVariable());

The table in the FSTable class can support up to 65536 different variables. As a result using the FSVariable class to reference the variables in the example above uses one byte rather than the five required to represent the name directly (including the null character terminating the string).

The FSTable stores the strings in an array. No checking for duplicate values is performed.

# History

The FSTable class represents the ActionConstantPool in the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 5. It was extended in Flash 6 to support tables of up to 65536 strings.

Field Summary

Fields inherited from class com.flagstone.transform.FSActionObject
`Call, ExceptionHandler, GetUrl, GetUrl2, GotoFrame, GotoFrame2, GotoLabel, If, Jump, length, NewFunction, NewFunction2, Push, RegisterCopy, SetTarget, Table, type, WaitForFrame, WaitForFrame2, With`

Constructor Summary
`FSTable()` Constructs an empty table.
`FSTable(java.util.ArrayList anArray)` Constructs an FSTable object using the array of strings.
`FSTable(FSCoder coder)` Construct an FSTable object, initialising it with values decoded from an encoded object.
`FSTable(FSTable obj)` Constructs an FSTable object by copying values from an existing object.

Method Summary
`void` | `add(java.lang.String aString)` Adds a String to the variable table.
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`java.lang.Object` | `clone()` Creates a deep copy of the entire object.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`java.util.ArrayList` | `getValues()` Gets the array of Strings stored in the variable table.
`int` | `length(FSCoder coder)`
`void` | `setValues(java.util.ArrayList anArray)` Sets the array of Strings stored in the literal table.

Methods inherited from class com.flagstone.transform.FSActionObject
`getType, length`

Methods inherited from class com.flagstone.transform.FSTransformObject
`name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSTable

    public FSTable(FSCoder coder)

  Construct an FSTable object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSTable

    public FSTable()

  Constructs an empty table.

### FSTable

    public FSTable(java.util.ArrayList anArray)

  Constructs an FSTable object using the array of strings.

  Parameters:
    `anArray` - of Strings that will be added to the table.

### FSTable

    public FSTable(FSTable obj)

  Constructs an FSTable object by copying values from an existing object.

  Parameters:
    `obj` - an FSGotoFrame object.

Method Detail

### add

    public void add(java.lang.String aString)

  Adds a String to the variable table.

  Parameters:
    `aString` - a String that will be added to the end of the table.

### getValues

    public java.util.ArrayList getValues()

  Gets the array of Strings stored in the variable table.

  Returns:
    the array of string literals.

### setValues

    public void setValues(java.util.ArrayList anArray)

  Sets the array of Strings stored in the literal table.

  Parameters:
    `anArray` - of Strings that will replaces the existing literal table.

### clone

    public java.lang.Object clone()

  Description copied from class: `FSTransformObject`
  Creates a deep copy of the entire object.

  Overrides:
    `clone` in class `FSTransformObject`
  Returns:
    a copy of the object.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSActionObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSActionObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Specified by:
    `appendDescription` in class `FSTransformObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSActionObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSActionObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSActionObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD